import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
/**
 * Write a description of class Blink here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Blink extends Skill
{
    int mouseX;
    int mouseY;
    
    public Blink()
    {
        Name = "Blink";
        
        cost = 30;
        last = 1.5;
        
        GreenfootImage G = new GreenfootImage(1,1);
        setImage(G);
    }
    public Blink(Player p)
    {
        Name = "Blink";
        
        cost = 30;
        last = 1.5;
        
        player = p;
        
        GreenfootImage G = new GreenfootImage(1,1);
        setImage(G);
        
        mouseX = Int(player.X);
        mouseY = Int(player.Y);
        //shardow = new Shardow(player.getImage());
    }
    
    public void RunIn() 
    {
        startTime = System.currentTimeMillis();
        player.getImage().setTransparency(100);
        player.invisible = true;
    }   
    
    public void Running()
    {
        getTimeSetting();
        Color C = new Color(player.color.getRed(), player.color.getGreen(), player.color.getBlue(), 150);
        getWorld().getBackground().setColor(C);
        
        //Greenfoot.mouseClicked(this.getWorld());
        MouseInfo mouse = Greenfoot.getMouseInfo();
        boolean clicked = false;
        try
        {
            if(mouse.getButton() == 1)
            clicked = true;
        }
        catch(java.lang.NullPointerException e)
        {
            clicked = false;
        }
        if(clicked)
        {
            int X = mouse.getX();
            int Y = mouse.getY();
            
            Spark[] spark = new Spark[18];
            for(int i = 0; i < 12; i++)
            {
                spark[i] = new Spark(player.color);
                spark[i].life = 0.5;
                spark[i].V = 100;
                spark[i].setV0();
                spark[i].X = player.X;
                spark[i].Y = player.Y;
                getWorld().addObject(spark[i], Int(spark[i].X), Int(spark[i].Y));
            }
            
            for(int i = 0; i < 12; i++)
            {
                spark[i] = new Spark(player.color);
                spark[i].life = 0.5;
                spark[i].V = 100;
                spark[i].setV0();
                spark[i].X = X;
                spark[i].Y = Y;
                getWorld().addObject(spark[i], Int(spark[i].X), Int(spark[i].Y));
            }
            
            player.X = X;
            player.Y = Y;
            
            this.startTime = 0;
        }
    }
    
    public void Running(int dx ,int dy)
    {
        int X = Int(player.X + dx);
        int Y = Int(player.Y + dy);
        
        Spark[] spark = new Spark[18];
        for(int i = 0; i < 12; i++)
        {
            spark[i] = new Spark(player.color);
            spark[i].life = 0.5;
            spark[i].V = 100;
            spark[i].setV0();
            spark[i].X = player.X;
            spark[i].Y = player.Y;
            getWorld().addObject(spark[i], Int(spark[i].X), Int(spark[i].Y));
        }
 
        for(int i = 0; i < 12; i++)
        {
            spark[i] = new Spark(player.color);
            spark[i].life = 0.5;
            spark[i].V = 100;
            spark[i].setV0();
            spark[i].X = X;
            spark[i].Y = Y;
            getWorld().addObject(spark[i], Int(spark[i].X), Int(spark[i].Y));
        }
        
        player.X = X;
        player.Y = Y;
        
        this.startTime = 0;
    }
    
    public void RunOut() 
    {
        player.getImage().setTransparency(255);
        player.invisible = false;
    }
}
