import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
/**
 * Write a description of class Enemy here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Enemy extends Shooter
{
    double ShootCD = 0.8;
    EnemyBullet bullet;
    int singleShoot = 2;

    boolean safe = false;
    boolean settled = false;
    public Enemy()
    {
        getTimeSetting();

        lastShardow = 0;
        lastShoot = 0;

        V = 20;

        int r = Greenfoot.getRandomNumber(128) + 128;
        int g = Greenfoot.getRandomNumber(128) + 128;
        int b = Greenfoot.getRandomNumber(128) + 128;
        color = new Color(r, g, b);
        Draw();
        setImage(G);
        //setRotation(180);
    }

    public Enemy(int x)
    {
        getTimeSetting();

        lastShardow = 0;
        lastShoot = 0;

        V = 20;

        mod = x;
        nextmod = mod;
        if(mod == 4)
        {
            V = 0;
        }

        int r = Greenfoot.getRandomNumber(128) + 128;
        int g = Greenfoot.getRandomNumber(128) + 128;
        int b = Greenfoot.getRandomNumber(128) + 128;
        color = new Color(r, g, b);
        Draw();
        setImage(G);
        //setRotation(180);
    }

    public void act() 
    {
        getTimeSetting();
        Move();
        if(isChanging)
            Change();
        else
        {
            SetBound();
            setFollower();
            if(mod != 4)
                Shardow();
            Attack();
            if(mod == 1)
                Shoot();
            if(safe)
                ClearBottom();
            isAway();
        }
    } 

    public void Shoot()
    {

        if(newTime - lastShoot > ShootCD * 1000.0 / Speed)
        {
            for(int j = 2; j < 3; j ++)
            {
                j += (singleShoot % 2) * 2;
                singleShoot++;
                bullet = new EnemyBullet();
                bullet.X = X + follower[j].dx;
                bullet.Y = Y;
                bullet.oldX = X + follower[j].dx;
                bullet.oldY = Y;
                bullet.color = color;
                bullet.Draw();
                getWorld().addObject(bullet, Int(bullet.X), Int(bullet.Y));

                for(int i = 0; i < 5; i++)
                {
                    spark[i] = new Spark(color);
                    spark[i].life = 0.2;
                    spark[i].V = 30;
                    spark[i].setV0();
                    spark[i].X = X + follower[j].dx;
                    spark[i].Y = Y + 8;
                    spark[i].Vy += Vy;
                    getWorld().addObject(spark[i], Int(spark[i].X), Int(spark[i].Y));
                }

                explode = new Explode(color);
                explode.life = 0.3;
                explode.X = X + follower[j].dx;
                explode.Y = Y + 8;
                getWorld().addObject(explode, Int(explode.X), Int(explode.Y));
            }

            lastShoot = newTime;
        }
    }

    public void Attack()
    {
        Player player = ((Space)getWorld()).player;
        double x = player.X - getX();
        double y = player.Y - getY();
        double d = getSum(x, y);
        if(d <= 15 && !player.invisible && !safe)
        {
            player.Dead();
            Dead();
        }
    }

    public void ClearBottom()
    {
        for(int i = 0; i < 25; i++)
        {
            Enemy bottom = (Enemy)getOneObjectAtOffset(0, i, Enemy.class);
            if(bottom != null && bottom.safe)
            {
                bottom.Dead();
                ((Space)getWorld()).control.Score += 50;
            }
        }
    }

    public void Move()
    {
        if(mod == 1 && (((Space)getWorld()).scene.mod == 1 || ((Space)getWorld()).scene.mod == 2))
        {
            Y += V * timeSpace;
            Locate(X, Y);
        }

        if(((Space)getWorld()).scene.mod == 3 && !isChanging)
        {
            Y += V * timeSpace;
            Y += ((Space)getWorld()).player.Vyy * timeSpace;
            Locate(X, Y);
        }

        if((mod == 4 || nextmod == 4) && ((Space)getWorld()).scene.mod == 2 && !safe)
        {
            int i = (getX() - 180) / 27 + 5;
            if(((Space)getWorld()).generator.Bottom[i] && ((Space)getWorld()).generator.BottomPush[i])
                Locate(X, Y);
            else
                Locate(X, Y + ((Space)getWorld()).generator.BrickDown);
        }
        if(mod == 4 && ((Space)getWorld()).scene.mod == 2 && safe && !settled)
        {
            Y += V * timeSpace;
            Y = Math.max(30, Y);
            Y = Math.min(430, Y);
            Locate();
            if(Y == 30 || Y == 430)
            {
                int i = (getX() - 180) / 27 + 5;
                if(V > 0)
                {
                    ((Space)getWorld()).generator.BottomSettled[i] = true;
                    settled = true;
                }
                if(V < 0)
                {
                    ((Space)getWorld()).generator.TopSettled[i] = true;
                    settled = true;
                }
            }
        }
    }

    public void setFollower0()
    {
        follower = new Follower[6];
        for(int i = 0; i < 6; i++)
            Fy[3][i] = -Fy[3][i];

        follower[0] = new Follower(this, 8 * Size + 1,  1 * Size,       Fx[mod][0] * Size,    Fy[mod][0] * -Size);
        follower[1] = new Follower(this, 8 * Size + 1,  1 * Size,       Fx[mod][1] * Size,    Fy[mod][1] * -Size);
        follower[2] = new Follower(this, 1 * Size,      2 * Size + 1,   Fx[mod][2] * Size,    Fy[mod][2] * -Size);
        follower[3] = new Follower(this, 1 * Size,      2 * Size + 1,   Fx[mod][3] * Size,    Fy[mod][3] * -Size);
        follower[4] = new Follower(this, 1 * Size,      2 * Size + 1,   Fx[mod][4] * Size,    Fy[mod][4] * -Size);
        follower[5] = new Follower(this, 1 * Size,      2 * Size + 1,   Fx[mod][5] * Size,    Fy[mod][5] * -Size);

        for(int i = 0; i < 6; i++)
        {
            follower[i].a = Fa[mod][i];
            getWorld().addObject(follower[i], Int(follower[i].X + follower[i].dx), Int(follower[i].Y + follower[i].dy));
        }
    }

    public void setFollower()
    {
        double Rate = (double)(newTime - lastShoot) / 1000.0 / ShootCD;
        Rate = 1 - Rate;
        Rate = Math.min(Rate, 1);
        for(int i = 0; i < 6; i++)
        {
            follower[i].dx = Fx[mod][i] * Size;
            follower[i].dy = Fy[mod][i] * -Size;
            follower[i].a = Fa[mod][i];
        }
        if(mod == 1)
        {
            follower[2].dy = -1 * Size  - Int(Rate * 2 * Size);
            follower[4].dy = -1 * Size  - Int(Rate * 2 * Size);
        }
    }

    public void Change()
    {
        if(nextmod != mod && isChanging)
        {
            double Rate = (double)(newTime - lastChange) / 1000.0 / changeSpeed;
            if(0 < Rate && Rate <= 1)
                for(int i = 0; i < 6; i++)
                {
                    follower[i].dx = Int(Fx[mod][i] * Size * (1 - Rate) + Fx[0][i] * Size * Rate);
                    follower[i].dy = Int(Fy[mod][i] * -Size * (1 - Rate) + Fy[0][i] * -Size * Rate);
                    follower[i].a  = Int(Fa[mod][i] * (1 - Rate) + Fa[0][i] * Rate);
            }
            if(1 < Rate && Rate <= 2 && !halfChange)
                for(int i = 0; i < 6; i++)
                {
                    follower[i].dx = Fx[0][i] * Size;
                    follower[i].dy = Fy[0][i] * -Size;
                    follower[i].a  = Fa[0][i];
                    halfChange = true;
            }
            if(2 < Rate && Rate <= 3)
                for(int i = 0; i < 6; i++)
                {
                    Rate -= 2;
                    follower[i].dx = Int(Fx[0][i] * Size * (1 - Rate) + Fx[nextmod][i] * Size * Rate);
                    follower[i].dy = Int(Fy[0][i] * -Size * (1 - Rate) + Fy[nextmod][i] * -Size * Rate);
                    follower[i].a  = Int(Fa[0][i] * (1 - Rate) + Fa[nextmod][i] * Rate);
                    Rate += 2;
            }

            if(Rate > 3 && halfChange)
            {
                mod = nextmod;
                halfChange = false;
                isChanging = false;
            }
        }
    }

    public void isAway()
    {
        if(Y < 20 && mod == 3 && ((Space)getWorld()).scene.mod == 3)
        {
            V = 0;
            ChangeTo(4);
        }

        if(X < 0 || X > 360 || Y < 0 || Y > 450)
        {
            if(mod == 4 && ((Space)getWorld()).scene.mod == 2 && !safe && ((Space)getWorld()).player.Life > -1)
                ((Space)getWorld()).player.Dead();

            Disappear();
        }
    }  

    public void Disappear()
    {
        ((Space)getWorld()).scene.kill++;

        for(int i = 0; i < 6; i++)
        {
            getWorld().removeObject(follower[i]);
        }
        
        if(((Space)getWorld()).scene.mod != 3)
        {
            ((Space)getWorld()).control.Score += 50;
            ((Space)getWorld()).player.upPower(10);
        }

        getWorld().removeObject(this);
    }
}
