import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
/**
 * Write a description of class EnemyBullet here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class EnemyBullet extends Bullet
{
    boolean tracing = true;
    
    
    public void Effect()
    {
        Ax = 0;
        Ay = 0;
        PointList = getObjectsInRange(1000, Point.class);
        if(!PointList.isEmpty())
        for(int i = 0; i < PointList.size(); i++)
        {
            point = (Point)PointList.get(i);
            Do();
        }
        
        Tracing();
    }
    
    public void Do()
    {
        Dx = X - point.X;
        Dy = Y - point.Y;
        D = getSum(Dx, Dy);

        if(point.Push)
        {
            Ax += Dx * point.power / Math.pow(D, point.Rate) * 4000;
            Ay += Dy * point.power / Math.pow(D, point.Rate) * 4000;
        }
    }
    
    public void Tracing()
    {
        Player player = ((Space)getWorld()).player;
        double x = X - player.X;
        if(!player.invisible && tracing)
        {
            Ax -= 50 * x /200;
        }
    }

    public void Attack()
    {
        Player player = ((Space)getWorld()).player;
        double x = player.X - X;
        double y = player.Y - Y;
        double d = getSum(x, y);
        if(d <= 8 && !player.invisible)
        {
            player.Dead();
            Disappear();
        }
    }

    public EnemyBullet()
    {
        oldTime = System.currentTimeMillis();
        newTime = oldTime;
        
        Vx = 0;
        Vy = 200;
        V = getV();
        
        Ax = 0;
        Ay = 0;
        A = getA();
        
        //color = Color.CYAN;
        Draw();
        G = new GreenfootImage(G0);
        setImage(G);
        
        power = 1;
    }  
}
