import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.lang.Math;
import java.util.List;
import java.awt.Color;
/**
 * Write a description of class Generator here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Generator extends timer
{
    public
    double BrickDown = 0;
    double BrickDownSpeed = 0.5;

    double CD = 6;
    double BandCD = 1;
    double Speed3 = 1;
    double score = 12;

    Enemy enemy;

    boolean[] Bottom = {false, false, false, false, false, false, false, false, false, false, false};
    boolean[] BottomSettled = {false, false, false, false, false, false, false, false, false, false, false};
    boolean[] BottomPush = {false, false, false, false, false, false, false, false, false, false, false};
    boolean[] Top = {false, false, false, false, false, false, false, false, false, false, false};
    boolean[] TopSettled = {false, false, false, false, false, false, false, false, false, false, false};
    boolean[] TopPull = {false, false, false, false, false, false, false, false, false, false, false};

    Enemy band;

    Player player;
    Scene scene;

    GlowArea glowArea;
    boolean Push;
    boolean PushInMiddle;
    double ForceSpace = 5;
    double waveHead = 0;

    public Generator()
    {
        lastGenerate = 0;
        GreenfootImage G = new GreenfootImage(1, 1);
        setImage(G);

        band = new Enemy(4);
        band.Y = 430;
    }

    public void Link()
    {
        player = ((Space)getWorld()).player;
        scene = ((Space)getWorld()).scene;
    }

    public void act() 
    {
        getTimeSetting();
        if(scene.mod == 1 && !scene.changing)
        {
            generatePlane();
        }

        if(scene.mod == 2 && !scene.changing)
        {
            generateBrick();
            setBrickDown();
        }

        if(scene.mod == 3 && !scene.changing)
        {
            generateCar();
        }

        genetatorBackBrick();
    }  

    public void generatePlane()
    {
        if(newTime - lastGenerate > CD * 1000.0 / Speed)
        {
            enemy = new Enemy();
            enemy.X = Greenfoot.getRandomNumber(358) + 1;
            enemy.Y = 10;
            getWorld().addObject(enemy, Int(enemy.X), Int(enemy.Y));
            enemy.setFollower0();
            lastGenerate = newTime;

            if(CD > 1)
                CD -= 0.1;
        }
    }

    public void generateBrick()
    {
        if(newTime - lastGenerate > CD * 1000.0 / Speed)
        {
            int x = 180 + (Greenfoot.getRandomNumber(11) - 5) * 27;
            int y = 200 + (Greenfoot.getRandomNumber(5) - 3) * 25;
            List Ob = getObjectsInRange(2000, Enemy.class);
            boolean hasBrick = false;
            if(!Ob.isEmpty())
                for(int i = 0; i < Ob.size(); i++)
                {
                    if(((Enemy)Ob.get(i)).X == x && ((Enemy)Ob.get(i)).Y == y )
                        hasBrick = true;
            }
            if(!hasBrick)
            {
                enemy = new Enemy(1);
                enemy.X = x;
                enemy.Y = y;
                enemy.V = 0;
                getWorld().addObject(enemy, Int(enemy.X), Int(enemy.Y));
                enemy.setFollower0();
                enemy.ChangeTo(4);
            }

            lastGenerate = newTime;

            if(CD > 1)
                CD -= 0.1;
        }
    }

    public void setBrickDown()
    {
        BrickDown += BrickDownSpeed * timeSpace;
        if(BrickDown > 25)
        {
            List Ob = getObjectsInRange(2000, Enemy.class);
            for(int i = 0; i < Ob.size(); i ++)
            {
                int x = (((Enemy)Ob.get(i)).getX() - 180) / 27 + 5;
                if(!((Enemy)Ob.get(i)).safe && ! BottomPush[x])
                    ((Enemy)Ob.get(i)).Y += 25;
            }
            BrickDown -= 25;
            BrickDownSpeed += 0.5;
        }
    }

    public void generateCar()
    {
        if(newTime - lastChange > ForceSpace * 1000 / Speed)
        {
            Push = !Push;
            waveHead = 20;
            lastChange = newTime;
            ForceSpace = (double)Greenfoot.getRandomNumber(4) + 4;
        }
        waveHead += player.Vyy * timeSpace;
        if(waveHead > player.Y - 15)
        PushInMiddle = Push;
        else
        PushInMiddle = !Push;
        if(player.Forced && PushInMiddle == !player.Push)
        player.upPower(8 * timeSpace);
        if(newTime - lastGenerate > CD * 1000.0 / Speed)
        {
            int x = 180 + (Greenfoot.getRandomNumber(11) - 5) * 27;
            enemy = new Enemy(3);
            enemy.X = x;
            enemy.Y = 430;
            enemy.V = -400;
            getWorld().addObject(enemy, Int(enemy.X), Int(enemy.Y));
            enemy.setFollower0();

            lastGenerate = newTime;

            if(CD > 0.7)
                CD -= 0.1;
        }

        if(band.Y > 3 * 27)
        {
            band = new Enemy(4);
            band.setColor(Color.GRAY);
            band.X = 180 - 6 * 27;
            band.Y = 20;
            getWorld().addObject(band, Int(band.X), Int(band.Y));
            band.setFollower0();

            band = new Enemy(4);
            band.setColor(Color.GRAY);
            band.X = 180 + 6 * 27;
            band.Y = 20;
            getWorld().addObject(band, Int(band.X), Int(band.Y));
            band.setFollower0();

            if(Push)
                glowArea = new GlowArea(Color.RED);
            else
                glowArea = new GlowArea(Color.BLUE);
            glowArea.X = 180;
            glowArea.Y = 20;
            getWorld().addObject(glowArea, Int(glowArea.X), Int(glowArea.Y));

            lastBand = newTime;
        }
        
        if(!player.Forced || PushInMiddle == player.Push)
        Speed3 += 0.007 * timeSpace;
        Speed3 += 0.003 * timeSpace;
        ((Space)getWorld()).control.setSpeed(Speed3);
        ((Space)getWorld()).control.Score += score * timeSpace * ((Space)getWorld()).control.Speed;
    }

    public void genetatorBackBrick()
    {
        if(newTime - lastBackBrick > 0.5 * 1000.0)
        {
            int x = Greenfoot.getRandomNumber(36) * 10;
            BackBrick backBrick = new BackBrick();
            backBrick.X = x;
            backBrick.Y = -300;
            getWorld().addObject(backBrick, x, -300);
            lastBackBrick = newTime;
        }
    }

}
