import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Write a description of class myBullet here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class MyBullet extends Bullet
{
    public MyBullet()
    {
        Vx = 0;
        Vy = -300;
        V = getV();
        
        Ax = 0;
        Ay = 0;
        A = getA();
        
        color = Color.WHITE;
        Draw();
        G = new GreenfootImage(G0);
        setImage(G);
        
        power = 1;
    } 
    
    public void Do()
    {
        Dx = X - point.X;
        Dy = Y - point.Y;
        D = getSum(Dx, Dy);

        if(!point.Push)
        {
            Ax = Dx * point.power / Math.pow(D, point.Rate) * 4000;
            Ay = Dy * point.power / Math.pow(D, point.Rate) * 4000;
            Ax = -Ax;
            Ay = -Ay;
        }
    }
    
    public void Attack()
    {
        EnemyList = getObjectsInRange(1000, Enemy.class);
        if(!EnemyList.isEmpty())
        {
            for(int i = 0; i < EnemyList.size(); i++)
            {
                double x = ((Enemy)EnemyList.get(i)).X - X;
                double y = ((Enemy)EnemyList.get(i)).Y - Y;
                double d = getSum(x, y);
                if(d <= 10 && !((Space)getWorld()).scene.changing && ((Enemy)EnemyList.get(i)).mod == 1)
                {
                    ((Enemy)EnemyList.get(i)).Dead();
                    Disappear();
                    break;
                }
                if(((Space)getWorld()).scene.changing)
                {
                    if(d <= 10 && ((Space)getWorld()).scene.mod == 1 && !((Enemy)EnemyList.get(i)).isChanging && ((Enemy)EnemyList.get(i)).mod != 4)
                    {
                        ((Enemy)EnemyList.get(i)).ChangeTo(4);
                        Disappear();
                        i = EnemyList.size();
                    }
                }
            }
        }
    }
}
