import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
/**
 * 飞机类
 */
public class Shooter extends object
{
    public
    double ShootCD = 0.3;
    double ShardowCD = 0.3;

    Bullet bullet;
    //int power;  //子弹威力 在1~4 之间
    
    Spark[] spark =  new Spark[30];
    Explode explode;
    Color color = Color.WHITE;
    GreenfootImage G;
    int Size = 3;
    int mod = 1;
    int nextmod = 1;
    int[][] Fx = {{-4,4,-8,-8,8,8},         {0,0,6,7,-6,-7},            {-8,8,-3,-13,13,3},         {-3,3,-5,-4,4,5},       {-4,4,-3,-3,3,3}};
    int[][] Fy = {{0,0,8,-8,-8,8},          {1,2,1,2,1,2},              {0,0,0,0,0,0},              {-2,-2,2,-7,-7,2},      {0,0,3,-3,-3,3}};
    int[][] Fa = {{90,90,45,135,225,315},   {0,180,0,180,180,360},      {180,0,0,180,180,360},      {-90,270,0,180,180,360},      {270,-90,0,180,180,360}};
    double changeSpeed = 0.5;
    boolean isChanging = false;
    boolean halfChange = false;
    
    double X0;
    double X1;
    double Y0;
    double Y1;
    boolean Forced = false;
    boolean Push = true;
    
    Follower[] follower;
    
    public Shooter()
    {
        lastShardow = 0;
        lastShoot = 0;
        
        Draw();
        setImage(G);
    }
    
    
    
    public void act() 
    {
        getTimeSetting();
        //Move();
        if(mod == 4)
        SetBound();
        setFollower();
        Shardow();
        Shoot();
    } 
    
    public void Shoot()
    {
        //
    }
    
    public void Shardow()
    {
        if(newTime - lastShardow > ShardowCD * 1000 / Speed)
        {
            for(int i = 0; i < 1; i++)
            {
                //double rate = Greenfoot.getRandomNumber(1000) / 1000.0;
                //double x = (X - oldX) * rate + oldX;
                //double y = (Y - oldY) * rate + oldY;
                //Spark shardow = (Spark)getOneObjectAtOffset(Int(x - X), Int(y - Y), Spark.class);
                //if(shardow == null)
                {
                    if(mod == 3)
                    ShardowCD = 0.1;
                    if(mod != 3)
                    ShardowCD = 0.5;
                    
                    Tail shardow = new Tail(color);
                    if(mod != 3)
                    shardow.Vy = -50;
                    if(mod == 3)
                    shardow.Vy = 50;
                    shardow.life = 0.2;
                    shardow.X = X;
                    if(mod != 3)
                    shardow.Y = Y - 8;
                    if(mod == 3)
                    shardow.Y = Y + 8;
                    getWorld().addObject(shardow, Int(shardow.X), Int(shardow.Y));
                }
            }
            lastShardow = newTime;
        }
    }
    
    public void Shardow0()
    {
        for(int i = 0; i < 30; i++)
        {
            double rate = Greenfoot.getRandomNumber(1000) / 1000.0;
            double x = (X1 - X0) * rate + X0;
            Spark shardow = (Spark)getOneObjectAtOffset(Int(X - x), 0, Spark.class);
            if(shardow == null)
            {
                shardow = new Spark(color);
                shardow.Vy += 50;
                shardow.life = 0.5;
                shardow.X = x;
                shardow.Y = Y;
                getWorld().addObject(shardow, Int(x), Int(Y));
            }
        }
    }
    
    public void Dead()
    {
        spark = new Spark[18];
        for(int i = 0; i < 18; i++)
        {
            spark[i] = new Spark(color);
            spark[i].life = 1.5;
            spark[i].V = 50;
            spark[i].setV0();
            spark[i].X = getX();
            spark[i].Y = getY();
            getWorld().addObject(spark[i], Int(spark[i].X), Int(spark[i].Y));
        }
        
        explode = new Explode(color);
        explode.life = 0.3;
        explode.X = getX();
        explode.Y = getY();
        getWorld().addObject(explode, Int(explode.X), Int(explode.Y));
        
        Disappear();
    }
    public void Disappear()
    {
        for(int i = 0; i < 6; i++)
        {
            getWorld().removeObject(follower[i]);
        }
        
        getWorld().removeObject(this);
    }
    
    
    
    
    public void setFollower0()
    {
        follower = new Follower[6];
        follower[0] = new Follower(this, 8 * Size + 1,  Size,           Fx[mod][0] * Size,   Fy[mod][0] * Size);
        follower[1] = new Follower(this, 8 * Size + 1,  Size,           Fx[mod][1] * Size,   Fy[mod][1] * Size);
        follower[2] = new Follower(this, Size,          2 * Size + 1,   Fx[mod][2] * Size,   Fy[mod][2] * Size);
        follower[3] = new Follower(this, Size,          2 * Size + 1,   Fx[mod][3] * Size,   Fy[mod][3] * Size);
        follower[4] = new Follower(this, Size,          2 * Size + 1,   Fx[mod][4] * Size,   Fy[mod][4] * Size);
        follower[5] = new Follower(this, Size,          2 * Size + 1,   Fx[mod][5] * Size,   Fy[mod][5] * Size);
        
        for(int i = 0; i < 6; i++)
        {
            follower[i].a = Fa[mod][i];
            getWorld().addObject(follower[i], Int(follower[i].X + follower[i].dx), Int(follower[i].Y + follower[i].dy));
        }
    }
    
    public void setFollower()
    {
        double Rate = (double)(newTime - lastShoot) / 1000.0 / ShootCD;
        Rate = 1 - Rate;
        for(int i = 0; i < 6; i++)
        {
            follower[i].dx = Fx[mod][i] * Size;
            follower[i].dy = Fy[mod][i] * Size;
            follower[i].a = Fa[mod][i];
        }
        if(mod == 1)
        {
            follower[2].dy = 1 * Size  + Int(Rate * 2 * Size);
            follower[4].dy = 1 * Size  + Int(Rate * 2 * Size);
        }
    }
    
    public void ChangeTo(int x)
    {
        if(x != mod && !isChanging)
        {
            isChanging = true;
            nextmod = x;
            lastChange = newTime;
        }
    }
    
    public void Change()
    {
        if(nextmod != mod && isChanging)
        {
            double Rate = (double)(newTime - lastChange) / 1000.0 / changeSpeed;
            if(0 < Rate && Rate <= 1)
            for(int i = 0; i < 6; i++)
            {
                follower[i].dx = Int(Fx[mod][i] * Size * (1 - Rate) + Fx[0][i] * Size * Rate);
                follower[i].dy = Int(Fy[mod][i] * Size * (1 - Rate) + Fy[0][i] * Size * Rate);
                follower[i].a  = Int(Fa[mod][i] * (1 - Rate) + Fa[0][i] * Rate);
            }
            if(1 < Rate && Rate <= 2 && !halfChange)
            for(int i = 0; i < 6; i++)
            {
                follower[i].dx = Fx[0][i] * Size;
                follower[i].dy = Fy[0][i] * Size;
                follower[i].a  = Fa[0][i];
                halfChange = true;
            }
            if(2 < Rate && Rate <= 3)
            for(int i = 0; i < 6; i++)
            {
                Rate -= 2;
                follower[i].dx = Int(Fx[0][i] * Size * (1 - Rate) + Fx[nextmod][i] * Size * Rate);
                follower[i].dy = Int(Fy[0][i] * Size * (1 - Rate) + Fy[nextmod][i] * Size * Rate);
                follower[i].a  = Int(Fa[0][i] * (1 - Rate) + Fa[nextmod][i] * Rate);
                Rate += 2;
            }
            
            if(Rate > 3 && halfChange)
            {
                mod = nextmod;
                halfChange = false;
                isChanging = false;
            }
        }
    }
    
    public void SetBound()
    {
        if(mod == 4)
        {
            X0 = getX() - Size * 4 - 1;
            X1 = getX() + Size * 4 + 1;
            Y0 = getY() - Size * 4;
            Y1 = getY() + Size * 4 + 1;
        }
        else
        if(mod == 2)
        {
            X0 = X + follower[3].dx - Size / 2;
            X1 = X + follower[4].dx + Size / 2;
            Y0 = Y;
            Y1 = 999999;
        }
        else
        {
            X0 = 0;
            X1 = 0;
            Y0 = 0;
            Y1 = 0;
        }
    }
    
    public void setForce(boolean f)
    {
        if(f)
        {
            Forced = true;
            if(Push)
            color = Color.RED;
            else
            color = Color.BLUE;
            Draw();
            setImage(G);
        }
        else
        {
            Forced = false;
            color = Color.WHITE;
            Draw();
            setImage(G);
        }
    }
    
    
    public void Draw()
    {
        G = new GreenfootImage(4 * Size + 1, 4 * Size + 1);
        G.setColor(color);
        G.fill();
    }
    public void Draw(int x)
    {
        G = new GreenfootImage(x, x);
        G.setColor(color);
        G.fill();
    }
    
    public void setColor(Color C)
    {
        color = C;
        Draw();
        setImage(G);
    }
}
