import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;
/**
 * Write a description of class world here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Space extends World
{
    long newTime;
    long oldTime;
    double timeSpace;


    Control control = new Control();
    Player player = new Player();
    Generator generator = new Generator();
    UI ui = new UI();
    Scene scene = new Scene();
    GreenfootImage BG0;
    GreenfootImage BG;
    
    double BG_down = 0;
    
    /**
     * Constructor for objects of class world.
     * 
     */
    public Space()
    {    
        super(360, 600, 1); 
        
        newTime = System.currentTimeMillis();
        oldTime = newTime;
        
        control = new Control();
        //player = new Player();
        generator = new Generator();
        ui = new UI();
        scene = new Scene();
        Draw0();
        

        addObject(generator, 0, 0);
        addObject(control, 0, 0);
        addObject(scene,0 ,0);
        
        player = new Player(scene.mod);
        addObject(player, 180, 400);
        addObject(player.skill, 0, 0);
        addObject(player.blink, 0, 0);
        player.setFollower0();
        
        addObject(ui, 180, 525);
        
        generator.Link();
        scene.Link();

        Draw0();
        Draw();
        
        setPaintOrder(Player.class, Shardow.class, UI.class, Bullet.class, Follower.class, Point.class, Enemy.class, GlowArea.class, BackBrick.class);
        setActOrder(Control.class, Player.class, Generator.class, UI.class);
        Greenfoot.start();
    }
    
    public void act()
    {
        getTimeSetting();
        Draw();
    }
    
    public void getTimeSetting()
    {
        newTime = System.currentTimeMillis();
        timeSpace = newTime - oldTime;
        timeSpace *= 0.001;
        oldTime = newTime;
    }
    

    
    
    public void started()
    {
        control.start();
        
        newTime = System.currentTimeMillis();
        oldTime = newTime;
    }
    
    public void Draw0()
    {
        BG0 = new GreenfootImage(360, 900);
        BG0.fill();
        for(int i = 0; i < 90; i ++)
        {
            int x = Greenfoot.getRandomNumber(36) * 10;
            //int y = Greenfoot.getRandomNumber(90) * 10;
            int y = i * 10;
            int c = (Greenfoot.getRandomNumber(6) + 1) * 8;
            Color C = new Color(c, c, c);
            BG0.setColor(C);
            BG0.fillRect(x, y, 61, 61);
        }
    }
    
    public void Draw()
    {
        BG = new GreenfootImage(360,600);
        BG.fill();
        BG_down += 20 * timeSpace;
        BG.drawImage(BG0, 0, Int(BG_down) - 300);
        if(BG_down > 200)
        {
            BG0.clear();
            BG0.drawImage(BG, 0, 300);
            BG_down = 0;
        }
        //BG.drawImage(BG0, 0, Int(BG_down));
        setBackground(BG);
    }
    
    
    public void Draw0000()
    {
        BG = new GreenfootImage(BG0);
        setBackground(BG);
    }
    
    
    
    
    public int Int(double x)
    {
        if(x > (int)x + 0.5)
        x = x + 1;
        else
        x = (int)x;
        return (int)x;
    }
    
}
