import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;
/**
 * Write a description of class UI here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class UI extends object
{
    GreenfootImage G0;
    GreenfootImage G;
    Color[] color = {Color.RED, Color.ORANGE, Color.YELLOW, Color.WHITE};
    int oldLife = 3;
    
    public UI()
    {
        G0 = new GreenfootImage(360, 150);
        G0.fill();
        setImage(G0);
    }
    
    public void act() 
    {
        Draw();
    }    
    
    public void Draw()
    {
        Player player = ((Space)getWorld()).player;
        
        G = new GreenfootImage(G0);
        G.setColor(Color.WHITE);
        G.drawLine(0, 0, 399, 0);
        Font F = new Font("Arial Black", Font.BOLD, 12);
        G.setFont(F);
        
        G.drawString("Score : " + String.valueOf(Int(((Space)getWorld()).control.Score)),5, 145);
        
        double speed = ((Space)getWorld()).control.Speed;
        speed = Int(10000 * speed) / 10000.0;
        String S = String.valueOf(speed);
        if(S.length() < 6)
        {
            for(int i = 0; i < 6 - S.length(); i++)
            {
                S += "0";
            }
        }
        G.drawString("Speed : " + S ,205, 145);

        
        int P = Int(player.Power);
        G.drawString("Power : ",5, 20);
        G.drawRect(65, 11, 200, 9);
        G.fillRect(65, 11, 2 * P, 9);
        G.drawString(String.valueOf(P) + " / 100",280, 20);
        
        G.drawString("Life : ",5, 48);
        if(player.Life < oldLife + 1 && player.Life >= 0)
        {
            Shardow(oldLife);
            oldLife = player.Life - 1;
        }
        if(player.Life >= 1)
        {
            G.setColor(color[0]);
            G.fillRect(55, 36, 15, 15);
        }
        if(player.Life >= 2)
        {
            G.setColor(color[1]);
            G.fillRect(80, 36, 15, 15);
        }
        if(player.Life >= 3)
        {
            G.setColor(color[2]);
            G.fillRect(105, 36, 15, 15);
        }
        if(player.Life >= 4)
        {
            G.setColor(color[3]);
            G.fillRect(130, 36, 15, 15);
        }
        G.setColor(Color.WHITE);
        
        
        F = new Font("Arial Black", Font.BOLD, 18);
        G.setFont(F);
        G.drawString(player.skill0.Name, 5, 105);
        
        F = new Font("Arial Black", Font.BOLD, 12);
        G.setFont(F);
        int Cost = Int(player.skill0.cost * player.skill0.last);
        if(player.Power >= Cost)
        G.setColor(Color.WHITE);
        else
        G.setColor(Color.RED);
        G.drawString("cost : " +String.valueOf(Cost), 200, 105);
        G.setColor(Color.WHITE);
        
        if(player.isCasting)
        {
            G.drawRect(5, 115, 200, 5);
            P = Int((1 - player.skill.lastTime / player.skill.last) * 200);
            G.fillRect(5, 115, P, 5);
        }
        
        setImage(G);
    }
    
    public void Shardow(int x)
    {
        double X = 137.5 - (3 - x) * 25;
        double Y = 43.5 + getY() - getImage().getHeight() / 2;
        Spark[] spark = new Spark[18];
        for(int i = 0; i < 18; i++)
        {
            spark[i] = new Spark(color[x]);
            spark[i].life = 1.5;
            spark[i].V = 50;
            spark[i].setV0();
            spark[i].X = X;
            spark[i].Y = Y;
            getWorld().addObject(spark[i], Int(spark[i].X), Int(spark[i].Y));
        }
        
        Explode explode = new Explode(color[x]);
        explode.life = 0.3;
        explode.X = X;
        explode.Y = Y;
        getWorld().addObject(explode, Int(explode.X), Int(explode.Y));
    }
}
