import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.awt.Color;
import java.lang.Math;

/**
 * 子弹类
 */
public class Bullet extends object
{
    public
    double CD = 0.01;
    

    
    int power;  //子弹威力 在1~4 之间
    
    List EnemyList;
    
    double D;
    double Dx;
    double Dy;
    List PointList;
    Point point;
    
    
    double a;
    int H;
    GreenfootImage G;
    GreenfootImage G0;
    Color color = Color.WHITE;
    
    public Bullet()
    {
        Vx = 0;
        Vy = -300;
        V = getV();
        
        Ax = 0;
        Ay = 0;
        A = getA();
        
        Draw();
        G = new GreenfootImage(G0);
        setImage(G);
        
        power = 1;
    }
    
    
    
    public void act()
    {
        getTimeSetting();
        
        Effect();
        setV();
        setL();
        Locate();
        
        Shardow();
        
        Attack();
        isAway();
    }
    
    public void Effect()
    {
        Ax = 0;
        Ay = 0;
        PointList = getObjectsInRange(1000, Point.class);
        if(!PointList.isEmpty())
        for(int i = 0; i < PointList.size(); i++)
        {
            point = (Point)PointList.get(i);
            Do();
        }
    }
    
    public void Do()
    {
        Dx = X - point.X;
        Dy = Y - point.Y;
        D = getSum(Dx, Dy);
        
        Ax = Dx * point.power / Math.pow(D, point.Rate) * 4000;
        Ay = Dy * point.power / Math.pow(D, point.Rate) * 4000;
        if(!point.Push)
        {
            Ax = -Ax;
            Ay = -Ay;
        }
    }
    
    
    public void Disappear()
    {
        getWorld().removeObject(this);
    }
    
    public void isAway()
    {
        if(X < 0 || X > 360 || Y < 0 || Y > 450)
        Disappear();
    }
    
    public void Attack()
    {
        EnemyList = getObjectsInRange(1000, Enemy.class);
        if(!EnemyList.isEmpty())
        {
            for(int i = 0; i < EnemyList.size(); i++)
            {
                double x = ((Enemy)EnemyList.get(i)).X - X;
                double y = ((Enemy)EnemyList.get(i)).Y - Y;
                double d = getSum(x, y);
                if( d <= 10)
                {
                    ((Enemy)EnemyList.get(i)).Dead();
                    Disappear();
                }
            }
        }
    }
    
    public void Shardow()
    {
        if(newTime - lastShardow > CD *1000 / Speed)
        {
            for(int i = 0; i < 1; i++)
            {
                double rate = Greenfoot.getRandomNumber(1000) / 1000.0;
                double x = (X - oldX) * rate + oldX;
                double y = (Y - oldY) * rate + oldY;
                Spark shardow = (Spark)getOneObjectAtOffset(Int(x - X), Int(y - Y), Spark.class);
                if(shardow == null)
                {
                    shardow = new Spark(color);
                    shardow.life = 0.2;
                    shardow.X = x;
                    if(Vy > 0)
                    shardow.X++;
                    shardow.Y = y;
                    getWorld().addObject(shardow, Int(x), Int(y));
                }
            }
            
            oldX = X;
            oldY = Y;
            
            lastShardow = newTime;
        }
    }
    
    
    
    
    
    
    
    
    
    
    public void Draw()
    {
        G0 = new GreenfootImage(4, 25);
        Color C = new Color(color.getRed(), color.getGreen(), color.getBlue(), 255);
        G0.setColor(C);
        G0.drawLine(1, 0, 1, 4);
        G0.drawLine(2, 0, 2, 4);
        C = new Color(color.getRed(), color.getGreen(), color.getBlue(), 150);
        G0.setColor(C);
        G0.drawLine(0, 1, 0, 4);
        G0.drawLine(3, 1, 3, 4);
        double rate = 1;
        for(int i = 5; i < 25; i++)
        {
            C = new Color(color.getRed(), color.getGreen(), color.getBlue(), Int(255 * rate));
            G0.setColor(C);
            G0.setColorAt(1, i, C);
            G0.setColorAt(2, i, C);
            C = new Color(color.getRed(), color.getGreen(), color.getBlue(), Int(150 * rate));
            G0.setColor(C);
            G0.setColorAt(0, i, C);
            G0.setColorAt(3, i, C);
            
            rate -= 0.05;
        }
    }
    
    public void setL()
    {
        X += Vx * timeSpace;
        Y += Vy * timeSpace;
    }
    
    public void setV()
    {
        Vx += Ax * timeSpace;
        Vy += Ay * timeSpace;
        V = getV();
        
        G = new GreenfootImage(G0);
        H = Int(G.getHeight() * Math.abs(V) / 300);
        H = Math.max(5, H);
        G.scale(G.getWidth(), H);
        setImage(G);
        a = (Math.atan(Vx / -Vy) * 180 / 3.14);
        if (Vy > 0)
        {
            a += 180;
        }
        setRotation(Int(a));
        //setRotation(90 + 180);
        getA();
    }
    
    public void power(int x)
    {
        if(x <= 1)
        power = 1;
        if(x >= 4)
        power = 4;
        else
        power = x;
    }
    
    
    public double getV()
    {
        return getSum(Vx, Vy);
    }
    
    public double getA()
    {
        return getSum(Ax, Ay);
    }
}
