import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class FastShoot here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class MadShoot extends Skill
{
    double speedUp = 7;

    public MadShoot()
    {
        Name = "MadShoot";
        
        cost = 25;
        last = 3;
    }
    public MadShoot(Player p)
    {
        Name = "MadShoot";
        
        cost = 25;
        last = 3;
        
        player = p;
    }
    
    public void RunIn() 
    {
        startTime = System.currentTimeMillis();
        if(((Space)getWorld()).scene.mod == 1)
        player.ShootCD /= speedUp;
    }   
    
    public void RunOut() 
    {
        if(((Space)getWorld()).scene.mod == 1)
        player.ShootCD *= speedUp;
    }   
    
    public void Shoot() 
    {
        for(int j = 2; j < 5; j += 2)
        {
            MyBullet bullet = new MyBullet();
            bullet.X = player.X + player.follower[j].dx;
            bullet.Y = player.Y;
            bullet.oldX = player.X + player.follower[j].dx;
            bullet.oldY = player.Y;
            bullet.Vx = (Greenfoot.getRandomNumber(1001) - 500) / 1000.0 * 150;
            player.getWorld().addObject(bullet, Int(bullet.X), Int(bullet.Y));

            for(int i = 0; i < 5; i++)
            {
                Spark[] spark = new Spark[5]; 
                spark[i] = new Spark(player.color);
                spark[i].life = 0.2;
                spark[i].V = 30;
                spark[i].setV0();
                spark[i].X = player.X + player.follower[j].dx;
                spark[i].Y = player.Y - 8;
                player.getWorld().addObject(spark[i], Int(spark[i].X), Int(spark[i].Y));
            }
            
            Explode explode = new Explode(player.color);
            explode.life = 0.1;
            explode.X = player.X + player.follower[j].dx;
            explode.Y = player.Y - 8;
            player.getWorld().addObject(explode, Int(explode.X), Int(explode.Y));
        }
        
        player.lastShoot = newTime;
    }
    
    public void Shoot0() 
    {
        Ball bullet = new Ball();
        bullet.X = player.X;
        bullet.Y = player.Y;
        bullet.oldX = player.X;
        bullet.oldY = player.Y;
        
        bullet.a = (Greenfoot.getRandomNumber(91) - 45) / 180.0 * 3.1415926535;
        bullet.Vx = bullet.V * Math.sin(bullet.a);
        bullet.Vy = -bullet.V * Math.cos(bullet.a);
        
        bullet.Push = player.Push;
        bullet.Forced = player.Forced;
        bullet.setForce(player.Forced);
        
        getWorld().addObject(bullet, Int(player.X), Int(player.Y));
    }
}
