import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.awt.Color;
/**
 * Write a description of class Player here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Player extends Shooter
{
    Bullet bullet; 
    double Power = 100;

    Skill skill;
    Skill skill0;
    String[] C = {"BulletTime", "ForceField", "Blink", "MadShoot"}; //"ForceField" , "PowerShoot" , "Invisible"
    int skillNum = 3;
    boolean isCasting = false;
    boolean invisible = false;
    
    double doubleHit = 0.15;
    boolean upA = true;
    boolean upD = true;
    Blink blink = new Blink(this);
    long lastA = 0;
    long lastD = 0;
    double BlinkCD = 2;
    int BlinkD = 65;
    
    boolean upQ = true;//开关力场的案件判定
    boolean upE = true;
    Point point;

    double Vyy = 200;
    double Ayy = 25;
    double Vz = 0;
    double Z = 0;
    boolean spaceUp = true;

    double ShardowCD = 0.15;
    int Life = 3;
    boolean hasBall;
    boolean clicked;

    public Player()
    {
        X = 180;
        Y = 400;
        V = 150;
        ShootCD = 0.3;
        //ShootCD = 999999999;

        Life++;
        skill = new Skill(this);
    }

    public Player(int m)
    {
        X = 180;
        Y = 400;
        V = 150;
        ShootCD = 0.3;
        //ShootCD = 999999999;
        mod = m;

        Life++;

        skill = new Skill(this);
    }

    public void Player00()
    {
        X = 180;
        if(mod == 1 || mod == 2)
            Y = 400;
        if(mod == 3)
        {
            Y = 250;
            Vyy = 200;
        }
        V = 150;
        Vyy = 200;
        ShootCD = 0.3;

        ((Space)getWorld()).generator.Speed3 = 1;
        ((Space)getWorld()).generator.CD = 6;
    }

    public void act() 
    {
        getTimeSetting();
        if(isChanging)
            Change();
        else
        {
            isForced();
            isPush();
            Move();
            SetBound();
            //TransForm();
            Cast();
            setFollower();
            Shardow();
            if(mod == 1 || mod == 4)
                Shoot0();
            if(mod == 2)
                Shoot1();
        }
    } 

    public void Shoot0()
    {
        if(newTime - lastShoot > ShootCD * 1000.0 / Speed)
        {
            for(int j = 2; j < 5; j += 2)
            {
                if(!isCasting)
                {
                    bullet = new MyBullet();
                    bullet.X = follower[j].X + follower[j].dx;
                    bullet.Y = follower[j].Y;
                    bullet.oldX = follower[j].X + follower[j].dx;
                    bullet.oldY = follower[j].Y;
                    getWorld().addObject(bullet, Int(bullet.X), Int(bullet.Y));
                }

                for(int i = 0; i < 5; i++)
                {
                    spark[i] = new Spark(color);
                    spark[i].life = 0.2;
                    spark[i].V = 30;
                    spark[i].setV0();
                    spark[i].X = X + follower[j].dx;
                    spark[i].Y = Y - 8;
                    getWorld().addObject(spark[i], Int(spark[i].X), Int(spark[i].Y));
                }

                explode = new Explode(color);
                explode.life = 0.1;
                explode.X = X + follower[j].dx;
                explode.Y = Y - 8;
                getWorld().addObject(explode, Int(explode.X), Int(explode.Y));
            }

            if(isCasting)
            {
                skill.Shoot();
            }

            lastShoot = newTime;
        }
    }

    public void Shoot1()
    {
        MouseInfo mouse = Greenfoot.getMouseInfo();
        clicked = false;
        try
        {
            if(mouse.getButton() == 1)
                clicked = true;
        }
        catch(java.lang.NullPointerException e)
        {
            clicked = false;
        }
        List BallList = getObjectsInRange(2000, Ball.class);
        hasBall = true;
        try
        {
            hasBall = !BallList.isEmpty();
        }
        catch(java.lang.NullPointerException e)
        {
            hasBall = false;
        }
        if(newTime - lastShoot > ShootCD * 1000.0 / Speed && clicked && !isCasting)
        {
            if(!isCasting && !hasBall)
            {
                bullet = new Ball();
                bullet.X = X;
                bullet.Y = Y;
                bullet.oldX = X;
                bullet.oldY = Y;

                bullet.a = (Greenfoot.getRandomNumber(91) - 45) / 180.0 * 3.1415926535;
                bullet.a = 0;
                bullet.Vx = bullet.V * Math.sin(bullet.a);
                bullet.Vy = -bullet.V * Math.cos(bullet.a);

                getWorld().addObject(bullet, Int(X), Int(Y));
            }

            for(int i = 0; i < 5; i++)
            {
                spark[i] = new Spark(color);
                spark[i].life = 0.2;
                spark[i].V = 30;
                spark[i].setV0();
                spark[i].X = X;
                spark[i].Y = Y - 8;
                getWorld().addObject(spark[i], Int(spark[i].X), Int(spark[i].Y));
            }

            explode = new Explode(color);
            explode.life = 0.1;
            explode.X = X;
            explode.Y = Y - 8;
            getWorld().addObject(explode, Int(explode.X), Int(explode.Y));

            lastShoot = newTime;
        }
        if(isCasting && newTime - lastShoot > ShootCD * 1000.0 / Speed)
        {
            skill.Shoot0();
            lastShoot = newTime;
        }
    }

    public void Move()
    {
        if(!((Space)getWorld()).scene.changing)
        {
            if(Greenfoot.isKeyDown("a"))
            {
                if(upA)
                {
                    upA = false;
                    if(newTime - lastA < doubleHit * 1000 && newTime - lastBlink > BlinkCD * 1000)
                    {
                        blink.Running(-BlinkD, 0);
                        lastBlink = newTime;
                    }
                }
                else
                {
                    X -= V * timeSpace;
                    lastA = newTime;
                    lastD = 0;
                }
            }
            else
                upA = true;
            if(Greenfoot.isKeyDown("d"))
            {
                if(upD)
                {
                    upD = false;
                    if(newTime - lastD < doubleHit * 1000 && newTime - lastBlink > BlinkCD * 1000)
                    {
                        blink.Running(BlinkD, 0);
                        lastBlink = newTime;
                    }
                }
                else
                {
                    X += V * timeSpace;
                    lastD = newTime;
                    lastA = 0;
                }
            }
            else
                upD = true;

            if(Greenfoot.isKeyDown("w") && mod == 1)
            {
                Y -= V * timeSpace;
            }
            if(Greenfoot.isKeyDown("w") && mod == 3)
            {
                Vyy += Ayy *timeSpace;
                Vyy = Math.min(300, Vyy);
            }
            if(Greenfoot.isKeyDown("s") && mod == 1)
            {
                Y += V * timeSpace;
            }
            if(Greenfoot.isKeyDown("s") && mod == 3)
            {
                Vyy -= Ayy *timeSpace;
                Vyy = Math.max(200, Vyy);
            }

            if(mod == 1)
            {
                X = Math.max(0 + 6 * Size, X);
                X = Math.min(360 - 6 * Size, X);
            }
            if(mod == 2)
            {
                X = Math.max(0 + 13 * Size, X);
                X = Math.min(360 - 13 * Size, X);
            }
            if(mod == 3)
            {
                X = Math.max(45, X);
                X = Math.min(315, X);
                //if(X < 45 || X > 315)
                //X = 180;
            }

            if(mod == 1)
            {
                Y = Math.max(330, Y);
                Y = Math.min(430, Y);
            }

            if(((Space)getWorld()).scene.mod == 3)
            {
                //if(Z == 0)
                    //Vz = 0;
                //if(Greenfoot.isKeyDown("space") && Z == 0 && Vz == 0 && Power > 45)
                if(Greenfoot.isKeyDown("space") && spaceUp && Z == 0)
                {
                    Vz = 20;
                    upPower(-45);
                    
                    spaceUp = false;
                }
                if(!Greenfoot.isKeyDown("space"))
                spaceUp = true;

                Vz -= 40 * timeSpace;
                Z += Vz * timeSpace;
                Z = Math.max(0,Z);
                //Vz = Math.max(0,Vz);
                if(Z != 0)
                    invisible = true;
                else
                    invisible = false;

                Draw(Size * 4 + 1 + 2 * Int(Math.pow(Z / 1.6, 2)));
                //G.setTransparency();
                setImage(G);

            }
            Locate();
        }
    }

    public void TransForm()
    {
        if(Greenfoot.isKeyDown("z"))
        {
            ChangeTo(1);
        }
        if(Greenfoot.isKeyDown("x"))
        {
            ChangeTo(2);
        }
        if(Greenfoot.isKeyDown("c"))
        {
            ChangeTo(3);
        }
        if(Greenfoot.isKeyDown("v"))
        {
            ChangeTo(4);
        }
    }

    public void setFollower()
    {
        double Rate = (double)(newTime - lastShoot) / 1000.0 / ShootCD;
        Rate = 1 - Rate;
        for(int i = 0; i < 6; i++)
        {
            follower[i].dx = Fx[mod][i] * Size;
            follower[i].dy = Fy[mod][i] * Size;
            follower[i].a = Fa[mod][i];
        }
        if(mod == 1)
        {
            follower[2].dy = 1 * Size  + Int(Rate * 2 * Size);
            follower[4].dy = 1 * Size  + Int(Rate * 2 * Size);
        }
        if(mod == 3)
        {
            int alpha = 30;
            if(Greenfoot.isKeyDown("a") && !Greenfoot.isKeyDown("d"))
            {
                follower[3].a -= alpha;
                follower[4].a -= alpha;
            }
            if(Greenfoot.isKeyDown("d") && !Greenfoot.isKeyDown("a"))
            {
                follower[3].a += alpha;
                follower[4].a += alpha;
            }
        }
    }

    public void Cast()
    {
        if(((Space)getWorld()).scene.mod == 1)
            upPower(1 * timeSpace);

        if(!isCasting)
        {
            //if(Greenfoot.isKeyDown("1"))
            //skillNum = 0;
            //if(Greenfoot.isKeyDown("2"))
            //skillNum = 1;
            //if(Greenfoot.isKeyDown("3"))
            //skillNum = 2;
            if(Greenfoot.isKeyDown("f"))
                skillNum = 3;
            switch(skillNum)
            {
                //case 0: skill0 = new BulletTime(this);   
                //break;
                //case 1: skill0 = new ForceField(this);   
                //break;
                //case 2: skill0 = new Blink(this);    
                //break;
                case 3: skill0 = new MadShoot(this);    
                break;
            }
        }

        if(!isCasting && Greenfoot.isKeyDown("f") && Power >= skill.cost * skill.last)
        {
            skill = null;
            switch(skillNum)
            {
                //case 0: skill = new BulletTime(this);   
                //break;
                //case 1: skill = new ForceField(this);   
                //break;
                //case 2: skill = new Blink(this);    
                //break;
                case 3: skill = new MadShoot(this);    
                break;
            }
            getWorld().addObject(skill, 0, 0);
            skill.RunIn();
            Power -= skill.cost * skill.last;
            isCasting = true;
        }
        if(isCasting)
        {
            if(Power > 0 && skill.lastTime < skill.last)
            {
                skill.Running();
            }
            else
            {
                skill.RunOut();
                isCasting = false;
            }
        }
    }

    public void isForced()
    {
        if(Greenfoot.isKeyDown("q") && upQ)
        {
            Forced = !Forced;
            setForce(Forced);

            if(Forced)
            {
                if(mod == 1)
                {
                    point = new Point(this);
                    point.Move();
                    getWorld().addObject(point, Int(point.X), 280);
                }
                if(mod == 2 || mod == 4)
                {
                    List BallList = getObjectsInRange(1000, Ball.class);
                    if(!BallList.isEmpty())
                        for(int i = 0; i < BallList.size(); i++)
                        {
                            ((Ball)BallList.get(i)).Push = Push;
                            ((Ball)BallList.get(i)).setForce(true);
                    }
                }
            }
            else
            {
                if(mod == 1)
                {
                    getWorld().removeObject(point);
                }
                if(mod == 2 || mod == 4)
                {
                    List BallList = getObjectsInRange(1000, Ball.class);
                    if(!BallList.isEmpty())
                        for(int i = 0; i < BallList.size(); i++)
                        {
                            ((Ball)BallList.get(i)).Push = Push;
                            ((Ball)BallList.get(i)).setForce(false);
                    }
                }
            }

            upQ = false;
        }
        if(!Greenfoot.isKeyDown("q"))
            upQ = true;
    }

    public void isPush()
    {
        if(Greenfoot.isKeyDown("e") && upE)
        {
            Push = !Push;
            if(mod == 2 || mod == 4)
            {
                List BallList = getObjectsInRange(1000, Ball.class);
                if(!BallList.isEmpty())
                    for(int i = 0; i < BallList.size(); i++)
                    {
                        ((Ball)BallList.get(i)).Push = Push;
                        ((Ball)BallList.get(i)).setForce(Forced);
                }
            }
            setForce(Forced);
            upE = false;
        }
        if(!Greenfoot.isKeyDown("e"))
            upE = true;
    }

    public void Dead()
    {
        Life--;
        if(Life < 0)
        {
            ((Space)getWorld()).control.Speed = 0;

            Disappear();
        }
        else
        {
            spark = new Spark[18];
            for(int i = 0; i < 18; i++)
            {
                spark[i] = new Spark(color);
                spark[i].life = 1.5;
                spark[i].V = 50;
                spark[i].setV0();
                spark[i].X = getX();
                spark[i].Y = getY();
                getWorld().addObject(spark[i], Int(spark[i].X), Int(spark[i].Y));
            }

            explode = new Explode(color);
            explode.life = 0.3;
            explode.X = getX();
            explode.Y = getY();
            getWorld().addObject(explode, Int(explode.X), Int(explode.Y));

            if(isCasting)
                skill.RunOut();
            Player00();

            skill0 = new Invisible(this);
            skill = new Invisible(this);
            skill.RunIn();
            isCasting = true;
        }
    }

    public void Shardow()
    {
        if(newTime - lastShardow > ShardowCD * 1000 / Speed)
        {
            for(int i = 0; i < 1; i++)
            {
                //double rate = Greenfoot.getRandomNumber(1000) / 1000.0;
                //double x = (X - oldX) * rate + oldX;
                //double y = (Y - oldY) * rate + oldY;
                //Spark shardow = (Spark)getOneObjectAtOffset(Int(x - X), Int(y - Y), Spark.class);
                //if(shardow == null)
                {
                    Tail shardow = new Tail(Color.WHITE);
                    shardow.Vy = 50;
                    shardow.life = 0.2;
                    shardow.X = X;
                    shardow.Y = Y + 8;
                    getWorld().addObject(shardow, Int(X), Int(Y) + 8);
                }
            }
            lastShardow = newTime;
        }
    }

    public void upPower(double x)
    {
        Power += x;
        Power = Math.max(0, Power);
        Power = Math.min(100, Power);
    }
}
