import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.lang.Math;
import java.util.List;
/**
 * Write a description of class Scene here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Scene extends timer
{
    int kill = 0;
    int mod = 1;

    boolean changing = false;
    boolean talking = false;
    int changeRate = 0;

    Player player;
    Generator generator;

    Enemy enemy;

    public Scene()
    {
        getTimeSetting();
        kill = 0;
        mod = 1;

        GreenfootImage G = new GreenfootImage(1, 1);
        setImage(G);

        changing = false;
        talking = false;
        changeRate = 0;
    }

    public void Link()
    {
        player = ((Space)getWorld()).player;
        generator = ((Space)getWorld()).generator;

        if(mod == 3)
        {
            player.X = 180;
            player.Y = 250;
            player.Locate();
        }
    }

    public void act() 
    {
        getTimeSetting();
        if(mod == 1 && !changing)
        {
            if(kill >= 0 && Greenfoot.isKeyDown("p"))
            {
                changing = true;
                startTime = newTime;
                lastTime = newTime - startTime;
                talking = true;
                Change1();
            }
        }
        if(changing && mod == 1)
        {
            Change1();
        }
        if(mod == 2 && !changing)
        {
            if(kill >= 0 && Greenfoot.isKeyDown("p"))
            {
                changing = true;
                startTime = newTime;
                lastTime = newTime - startTime;
                talking = true;
                Change2();
            }
        }
        if(changing && mod == 2)
        {
            Change2();
        }
    }

    public void Change1()
    {
        Player player = ((Space)getWorld()).player;
        player.ShootCD = 999999;
        if(lastTime < 0.5)
        {
            List Ob = getObjectsInRange(1000, Enemy.class);
            if(!Ob.isEmpty())
            {
                for(int i = 0; i < Ob.size(); i++)
                {
                    ((Enemy)Ob.get(i)).Dead();
                }
            }
            Ob = getObjectsInRange(1000, Bullet.class);
            if(!Ob.isEmpty())
            {
                for(int i = 0; i < Ob.size(); i++)
                {
                    ((Bullet)Ob.get(i)).Disappear();
                }
            }
        }
        if(0.5 < lastTime && lastTime < 1.5 && talking)
        {
            Dialogue D = new Dialogue("SO EASY!");
            D.X = player.X + 15 + D.G.getWidth() / 2.0;
            D.Y = player.Y - 35;
            ((Space)getWorld()).addObject(D, Int(D.X), Int(D.Y));
            talking = false;
        }
        if(1.5 < lastTime && lastTime < 2 && !talking)
        {
            talking = true;
            if(player.Forced && mod == 1)
                getWorld().removeObject(player.point);
            player.setForce(false);
        }
        if(2 < lastTime && lastTime < 3 && talking)
        {
            Dialogue D = new Dialogue("REALLY?");
            D.X = 200;
            D.Y = 20;
            ((Space)getWorld()).addObject(D, Int(D.X), Int(D.Y));
            talking = false;
        }
        if(lastTime >3 && lastTime < 5.5)
        {
            generator.CD = 0.5;
            if(newTime - lastGenerate > generator.CD * 1000.0 / Speed)
            {
                enemy = new Enemy();
                enemy.X = 180;
                enemy.Y = 200 - (changeRate - 2) * 25;
                enemy.lastShoot = newTime;
                enemy.ShootCD = 999999;
                enemy.V = 0;
                getWorld().addObject(enemy, Int(enemy.X), Int(enemy.Y));
                enemy.setFollower0();

                lastGenerate = newTime;
                changeRate++;
            }
            talking = true;
        }
        if(5.5 < lastTime && lastTime < 6 && talking)
        {
            Dialogue D = new Dialogue("PU~");
            D.X = player.X + 15 + D.G.getWidth() / 2.0;
            D.Y = player.Y - 35;
            ((Space)getWorld()).addObject(D, Int(D.X), Int(D.Y));
            talking = false;
        }
        if((player.X != 180 - 6 * player.Size || player.X != 180 + 6 * player.Size || player.Y != 400) && lastTime > 6.5)
        {
            if(player.X >= 180)
            {
                if(player.X > 180 + 6 * player.Size)
                    player.X -= player.V * timeSpace;
                if(player.X < 180 + 6 * player.Size)
                    player.X += player.V * timeSpace;
                player.X = Math.max(180 + 6 * player.Size, player.X);
            }
            if(player.X < 180)
            {
                if(player.X < 180 - 6 * player.Size)
                    player.X += player.V * timeSpace;
                if(player.X > 180 - 6 * player.Size)
                    player.X -= player.V * timeSpace;
                player.X = Math.min(180 - 6 * player.Size, player.X);
            }
            if(player.Y < 400 && (player.X == 180 - 6 * player.Size || player.X == 180 + 6 * player.Size))
            {
                player.Y += player.V * timeSpace;
                player.Y = Math.min(400, player.Y);
            }
            player.Locate();
            //startTime += timeSpace * 1000;
        }
        if(lastTime > 7.5 && lastTime < 10)
        {
            //lastTime = (newTime - startTime) / 1000.0;
            player.ShootCD = 0.5;      
            talking = true;
        }
        if(lastTime > 11 && lastTime < 12 && talking)
        {
            talking = false;
            Dialogue D = new Dialogue("WTF?!");
            D.X = player.X + 15 + D.G.getWidth() / 2.0;
            D.Y = player.Y - 35;
            ((Space)getWorld()).addObject(D, Int(D.X), Int(D.Y));
            talking = false;
        }
        if(lastTime > 13 && lastTime < 14 && !talking)
        {
            player.ChangeTo(2);
            talking = true;
        }
        if(lastTime > 15 && talking)
        {
            talking = false;
            Dialogue D = new Dialogue("(Click to Start)");
            D.X = player.X + 15 + D.G.getWidth() / 2.0;
            D.Y = player.Y - 35;
            ((Space)getWorld()).addObject(D, Int(D.X), Int(D.Y));
            lastTalk = newTime;
        }
        if(lastTime > 19 && !talking && newTime - lastTalk > 4000)
        {
            talking = true;
        }
        if(lastTime > 15)
        {
            MouseInfo mouse = Greenfoot.getMouseInfo();
            boolean clicked = false;
            try
            {
                if(mouse.getButton() == 1)
                    clicked = true;
            }
            catch(java.lang.NullPointerException e)
            {
                clicked = false;
            }
            if(clicked)
            {
                List Ob = getObjectsInRange(1000, Dialogue.class);
                if(!Ob.isEmpty())
                {
                    for(int i = 0; i < Ob.size(); i++)
                    {
                        ((Dialogue)Ob.get(i)).Disappear();
                    }
                }

                generator.CD = 3;
                player.ShootCD = 0.5;
                mod = 2;
                kill = 0;

                changing = false;
            }
        }  
    }

    
    
    
    
    
    public void Change2()
    {
        Player player = ((Space)getWorld()).player;
        player.ShootCD = 999999;
        if(lastTime < 0.5)
        {
            List Ob = getObjectsInRange(1000, Enemy.class);
            if(!Ob.isEmpty())
            {
                int x = Greenfoot.getRandomNumber(Ob.size());
                for(int i = 0; i < Ob.size(); i++)
                {
                    if(i != x)
                        ((Enemy)Ob.get(i)).Dead();
                    else
                        enemy = (Enemy)Ob.get(i);
                }
            }
            else
            {
                enemy = new Enemy(4);
                getWorld().addObject(enemy, 180, 200);
                enemy.setFollower0();
            }
            Ob = getObjectsInRange(1000, Bullet.class);
            if(!Ob.isEmpty())
            {
                for(int i = 0; i < Ob.size(); i++)
                {
                    ((Bullet)Ob.get(i)).Disappear();
                }
            }
        }
        if(0.5 < lastTime && lastTime < 1.5 && talking)
        {
            Dialogue D = new Dialogue("SOSO~");
            D.X = player.X + 15 + D.G.getWidth() / 2.0;
            D.Y = player.Y - 35;
            ((Space)getWorld()).addObject(D, Int(D.X), Int(D.Y));
            talking = false;
        }
        if(1.5 < lastTime && lastTime < 2 && !talking)
        {
            talking = true;
            if(player.Forced && mod == 1)
                getWorld().removeObject(player.point);
            player.setForce(false);
        }
        if(2 < lastTime && lastTime < 3 && talking)
        {
            Dialogue D = new Dialogue("UH?");
            D.X = 200;
            D.Y = 20;
            ((Space)getWorld()).addObject(D, Int(D.X), Int(D.Y));
            talking = false;
        }
        if(lastTime >3 && lastTime < 4 && !talking)
        {
            enemy.ChangeTo(3);
            if(!talking)
                talking = true;
        }
        if(lastTime > 4 && lastTime < 5 && talking)
        {
            talking = false;
            Dialogue D = new Dialogue("WTF?!");
            D.X = player.X + 15 + D.G.getWidth() / 2.0;
            D.Y = player.Y - 35;
            ((Space)getWorld()).addObject(D, Int(D.X), Int(D.Y));
        }
        if((player.X != 180 || player.Y != 250)&& lastTime > 6)
        {
            if(player.X > 180)
            {
                player.X -= player.V * timeSpace;
                enemy.X -= player.V * timeSpace;
                player.X = Math.max(180, player.X);
            }
            if(player.X < 180)
            {
                player.X += player.V * timeSpace;
                enemy.X += player.V * timeSpace;
                player.X = Math.min(180, player.X);
            }
            if(player.Y > 250 && player.X == 180)
            {
                player.Y -= player.V * timeSpace;
                enemy.Y -= player.V * timeSpace;
                player.Y = Math.max(250, player.Y);
            }
            if(player.Y < 250 && player.X == 180)
            {
                player.Y += player.V * timeSpace;
                enemy.Y += player.V * timeSpace;
                player.Y = Math.min(250, player.Y);
            }
            player.Locate();
            enemy.Locate();
        }
        if(lastTime > 8 && lastTime < 10 && !talking)
        {
            player.ChangeTo(3);
            talking = true;
        }
        if(lastTime > 11 && talking)
        {
            talking = false;
            Dialogue D = new Dialogue("(Click to Start)");
            D.X = player.X + 15 + D.G.getWidth() / 2.0;
            D.Y = player.Y - 35;
            ((Space)getWorld()).addObject(D, Int(D.X), Int(D.Y));
            talking = false;
            lastTalk = newTime;
        }
        if(lastTime > 15 && !talking && newTime - lastTalk > 4000)
        {
            talking = true;
        }
        if(lastTime > 11)
        {
            MouseInfo mouse = Greenfoot.getMouseInfo();
            boolean clicked = false;
            try
            {
                if(mouse.getButton() == 1)
                    clicked = true;
            }
            catch(java.lang.NullPointerException e)
            {
                clicked = false;
            }
            if(clicked)
            {
                List Ob = getObjectsInRange(1000, Dialogue.class);
                if(!Ob.isEmpty())
                {
                    for(int i = 0; i < Ob.size(); i++)
                    {
                        ((Dialogue)Ob.get(i)).Disappear();
                    }
                }

                generator.CD = 3;
                player.ShootCD = 0.5;
                enemy.V = -400;
                mod = 3;
                kill = 0;

                changing = false;
            }
        }
    }
}
